/*
 * Copyright (c) 1990-1993 Michael A. Cooper.
 * This software may be freely distributed provided it is not sold for 
 * profit and the author is credited appropriately.
 */

/*
 * $Id: config.h,v 6.1 1993/03/25 19:02:08 mcooper Exp mcooper $
 */

#ifndef __config_h__
#define __config_h__

/*
 * System configuration
 */

#include "config-data.h"

/*
 * Argument type
 */
#if	!defined(ARG_TYPE) && defined(__STDC__)
#define ARG_TYPE	ARG_STDARGS
#include <stdarg.h>
#endif
#if	!defined(ARG_TYPE) && defined(HAVE_VARARGS)
#define ARG_TYPE	ARG_VARARGS
#include <varargs.h>
#endif

/*
 * Regular expression type
 */
#if	!defined(RE_TYPE) && (defined(hpux) || defined(__hpux))
#define RE_TYPE		RE_REGCOMP
#endif
#if	!defined(RE_TYPE) && defined(SYSV)
#define RE_TYPE		RE_SYSV
#endif
#if	!defined(RE_TYPE)
#define RE_TYPE		RE_BSD
#endif

/*
 * Tty interface type
 */
#if	!defined(TTY_TYPE) && defined(_POSIX_SOURCE)
#define TTY_TYPE	TTY_POSIX
#include <termios.h>
#endif
#if	!defined(TTY_TYPE) && defined(SYSV)
#define TTY_TYPE	TTY_SYSV
#include <termio.h>
#endif
#if	!defined(TTY_TYPE)
#define TTY_TYPE	TTY_BSD
#include <sys/file.h>
#include <sgtty.h>
#endif

/*
 * Signal types
 */
#if	!defined(SIG_TYPE) && defined(_POSIX_SOURCE)
#define SIG_TYPE	SIGTYPE_POSIX
#endif
#if	!defined(SIG_TYPE)
#define SIG_TYPE	SIGTYPE_UNIX
#endif

#endif	/* __config_h__ */
